import ArmaMad

@objc(Momo)
class Momo: RCTEventEmitter, OnrampKitDelegate {

func onDataChanged(_ data: OnrampEventResponse) {
      do{
        let jsonData = try JSONEncoder().encode(data)
        let jsonString = String(data: jsonData, encoding: .utf8)
        if(jsonString != nil){
          self.sendEvent(withName: "widgetEvents", body: jsonString)
        }
      } catch {
        print("CONVERSION_ERROR", "Failed to convert Swift object to JSON", error)
      }

    }
    
    @objc
    override static func requiresMainQueueSetup() -> Bool {
      return true;
    }
    
    @objc
    override func constantsToExport() -> [AnyHashable: Any]! {
      return ["initialCount": 0];
    }
    
    @objc
    override func supportedEvents() -> [String]! {
      return ["widgetEvents"]
    }
    
    @available(iOS 13.0, *)
    @objc(startSdk:)
    func startSdk(_ params: NSDictionary){
      if let currentlyPresentedVC = RCTPresentedViewController() {
           DispatchQueue.main.async {
             ArmaMad.startOnrampSDK(currentlyPresentedVC.self, self, appId: params["appId"] as! Int, walletAddress: params["walletAddress"] as? String, flowType: params["flowType"] as? Int, coinCode: params["coinCode"] as? String, network: params["network"] as? String, coinAmount:  params["coinAmount"] as? Double, fiatAmount:  params["fiatAmount"] as? Double, merchantRecognitionId: params["merchantRecognitionId"] as?  String, paymentMethod:  params["paymentMethod"] as? Int, authToken:  params["authToken"] as? String, assetDescription:  params["assetDescription"] as? String, assetImage:  params["assetImage"] as? String, paymentAddress:  params["paymentAddress"] as? String)
           }
         }
       }
}
