import { NativeEventEmitter, NativeModules, Platform } from 'react-native';
import type { ConfigType } from './types';

const LINKING_ERROR =
  `The package 'react-native-momo' doesn't seem to be linked. Make sure: \n\n` +
  Platform.select({ ios: "- You have run 'pod install'\n", default: '' }) +
  '- You rebuilt the app after installing the package\n' +
  '- You are not using Expo Go\n';

const Momo = NativeModules.Momo
  ? NativeModules.Momo
  : new Proxy(
      {},
      {
        get() {
          throw new Error(LINKING_ERROR);
        },
      }
    );

export const startOnrampSDK = (config: ConfigType) => {
  if (!config.appId) {
    throw new TypeError("'appId is missing or null.'");
  }
  return Momo.startSdk(config);
};

export const onRampSDKNativeEvent = new NativeEventEmitter(NativeModules.Momo);
