export type ConfigType = {
  appId: number;
  walletAddress?: string;
  coinCode?: string;
  network?: string;
  coinAmount?: number;
  fiatAmount?: number;
  merchantRecognitionId?: string;
  paymentMethod?: number;
  flowType?: number;
  authToken?: string;
  assetDescription?: string;
  assetImage?: string;
  paymentAddress?: string;
  fiatType?: number;
};

export interface StatusUpdates extends Record<string, any> {
  msg: String | null;
  fiatAmount: Number | null;
  cryptoAmount: String | null;
  coinRate: Number | null;
  paymentMethod: String | null;
}

export interface OnrampSDKResult extends Record<string, any> {
  type: String;
  data?: StatusUpdates;
  isOnramp: boolean;
}
